entity im_ram_inst_example is
port (
    .
    .
);
end im_ram_inst_example;

architecture rtl of im_ram_inst_example is
   
    constant C_IMAGE_DIM : integer := 256;
    constant C_NUM_MEMS  : integer := 8;
    constant C_MEM_DEPTH : integer := C_IMAGE_DIM*C_IMAGE_DIM/C_NUM_MEMS;

    type Mem_data_array_t is array(0 to C_NUM_MEMS-1) of std_logic_vector(7 downto 0);
    signal wr_data : Mem_data_array_t;
    signal wr_addr : unsigned(clogb2(C_MEM_DEPTH)-1 downto 0);
    signal wren    : std_logic_vector(C_NUM_MEMS-1 downto 0);
    signal rd_data : Mem_data_array_t;
    signal rd_addr : unsigned(clogb2(C_MEM_DEPTH)-1 downto 0);
    
begin

    IM_MEMS: for i in 0 to C_NUM_MEMS-1 generate
        IM_MEMi : entity work.im_ram(Behavioral)
            generic map (
                G_RAM_WIDTH => 8,
                G_RAM_DEPTH => C_MEM_DEPTH,
                G_RAM_PERFORMANCE => "HIGH_PERFORMANCE",
                G_RAM_INIT_FILE => "lenaCorrupted" & integer'image(i) & ".dat") 
            port map (
                addra  => std_logic_vector(wr_addr),
                addrb  => std_logic_vector(rd_addr),
                dina   => wr_data(i),
                clka   => clk,
                wea    => wren(i),
                enb    => '1',
                rstb   => '0',
                regceb => '1',
                doutb  => rd_data(i)
            );
    end generate;
        
        
end rtl;
